
GLOBAL.setmetatable(env,{
__index = function (t,k)
return GLOBAL.rawget(GLOBAL,k)
end,
})

local _G = GLOBAL

GLOBAL.THE_FIRST_PART_ENABLE = false

for _, moddir in ipairs(GLOBAL.KnownModIndex:GetModsToLoad()) do
	local name = GLOBAL.KnownModIndex:GetModInfo(moddir).name
	local author = GLOBAL.KnownModIndex:GetModInfo(moddir).author
	if name and author then
	  if name == "Legendary Gifts for Valentine's Day" and author == "karas" then
		GLOBAL.THE_FIRST_PART_ENABLE = true
	  end
	end
end

if GLOBAL.THE_FIRST_PART_ENABLE then

local loc = _G.require "languages/loc"

GLOBAL.IS_CHINESE_LANGUAGE = false

if loc.GetLanguage() and loc.GetLanguage() == 22 or loc.GetLanguage()== 23 then

   GLOBAL.IS_CHINESE_LANGUAGE = true

end


Assets = 
{

    Asset( "IMAGE", "images/inventoryimages/rose_chest.tex" ),
    Asset( "ATLAS", "images/inventoryimages/rose_chest.xml" ),
	Asset( "IMAGE", "images/inventoryimages/rose_trash.tex" ),
    Asset( "ATLAS", "images/inventoryimages/rose_trash.xml" ),
	Asset( "IMAGE", "images/inventoryimages/rose_boomerang.tex" ),
    Asset( "ATLAS", "images/inventoryimages/rose_boomerang.xml" ),	
	Asset( "IMAGE", "images/inventoryimages/firepit_rose.tex" ),
    Asset( "ATLAS", "images/inventoryimages/firepit_rose.xml" ),	
    Asset( "IMAGE", "images/inventoryimages/rose_tool.tex" ),
    Asset( "ATLAS", "images/inventoryimages/rose_tool.xml" ),
	Asset( "IMAGE", "images/inventoryimages/smart_soup.tex" ),
    Asset( "ATLAS", "images/inventoryimages/smart_soup.xml" ),
	Asset( "IMAGE", "images/inventoryimages/rosecrown.tex" ),
    Asset( "ATLAS", "images/inventoryimages/rosecrown.xml" ),
	Asset( "IMAGE", "images/inventoryimages/tyrmask.tex" ),
    Asset( "ATLAS", "images/inventoryimages/tyrmask.xml" ),	
	Asset( "IMAGE", "images/inventoryimages/rose_amulet.tex" ),
    Asset( "ATLAS", "images/inventoryimages/rose_amulet.xml" ),		

}
PrefabFiles = {
"rose_chest",
"rose_trash",
"rose_chestlight",
"rose_boomerang",
"firepit_rose",
"rosefire",
"rose_tool",
"smart_soup",
"rosecrown",
"tyrmask",
"rose_amulet",
}



GLOBAL.CHESTSOUND = (GetModConfigData("chestsound")=="enabled")

if GLOBAL.IS_CHINESE_LANGUAGE then

STRINGS.NAMES.ROSE_CHEST = "守护"
STRINGS.RECIPE_DESC.ROSE_CHEST = "高大上的箱子。"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ROSE_CHEST = "我可以守住你的心！"

STRINGS.NAMES.ROSE_TRASH = "抛弃"
STRINGS.RECIPE_DESC.ROSE_TRASH = "变废为宝。"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ROSE_TRASH = "垃圾分类回收，你学会了吗？"

STRINGS.NAMES.ROSE_BOOMERANG = "多情"
STRINGS.RECIPE_DESC.ROSE_BOOMERANG = "敌人越多越强大。"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ROSE_BOOMERANG = "即使敌众我寡，末将。。末将还是想跑！"

STRINGS.NAMES.FIREPIT_ROSE = "赤诚"
STRINGS.RECIPE_DESC.FIREPIT_ROSE = "把玫瑰放进去。"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.FIREPIT_ROSE = "半夏微暖，半夏凉！"

STRINGS.NAMES.ROSE_TOOL = "花心"
STRINGS.RECIPE_DESC.ROSE_TOOL = "多功能工具。"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ROSE_TOOL = "打砸抢全能型选手！"

STRINGS.NAMES.SMART_SOUP = "聪明汤"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SMART_SOUP = "我感觉喝了之后反而变笨了，我是谁？我在哪？"

STRINGS.NAMES.ROSECROWN = "玫瑰王冠"
STRINGS.RECIPE_DESC.ROSECROWN = "智慧的象征"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ROSECROWN = "有了它我想我再也不用瞎转悠了。"

STRINGS.NAMES.TYRMASK = "提尔面具"
STRINGS.RECIPE_DESC.TYRMASK = "战争的艺术品"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TYRMASK = "它长了一对长獠牙。"

STRINGS.NAMES.ROSE_AMULET = "玫瑰之眼"
STRINGS.RECIPE_DESC.ROSE_AMULET = "恐怖的大眼睛"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ROSE_AMULET = "它似乎是活的。"

else

STRINGS.NAMES.ROSE_CHEST = "RoseChest"
STRINGS.RECIPE_DESC.ROSE_CHEST = "Noble and Gorgeous."
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ROSE_CHEST = "It can hold your heart."

STRINGS.NAMES.ROSE_TRASH = "Rose Trash"
STRINGS.RECIPE_DESC.ROSE_TRASH = "Turn Waste Into Treasure."
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ROSE_TRASH = "Don't put food in it when i'm hungry."

STRINGS.NAMES.ROSE_BOOMERANG = "Rose Boomerang"
STRINGS.RECIPE_DESC.ROSE_BOOMERANG = "More Enemies More Powerful."
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ROSE_BOOMERANG = "Keep spinning!"

STRINGS.NAMES.FIREPIT_ROSE = "Rose Firepit"
STRINGS.RECIPE_DESC.FIREPIT_ROSE = "Put The Roses In."
STRINGS.CHARACTERS.GENERIC.DESCRIBE.FIREPIT_ROSE = "Bright And Warm Accompany You."

STRINGS.NAMES.ROSE_TOOL = "Rose Tool"
STRINGS.RECIPE_DESC.ROSE_TOOL = "Multifunctional Tools."
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ROSE_TOOL = "I Don't Need Anything With It.."

STRINGS.NAMES.SMART_SOUP = "Smart Soup"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.SMART_SOUP = "I'm no longer afraid of tsunamis."

STRINGS.NAMES.ROSECROWN = "Rose Crown"
STRINGS.RECIPE_DESC.ROSECROWN = "Symbolic Wisdom"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ROSECROWN = "I'll never run around again."

STRINGS.NAMES.TYRMASK = "Tyr"
STRINGS.RECIPE_DESC.TYRMASK = "The Art of War"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.TYRMASK = "It has a pair of long tusks."

STRINGS.NAMES.ROSE_AMULET = "Eye Of Rose"
STRINGS.RECIPE_DESC.ROSE_AMULET = "Terror eyes"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ROSE_AMULET = "It seems to be a living thing."

end	

local rose_chest = Recipe("rose_chest",  {Ingredient("rose_worked", 5,"images/inventoryimages/rose_worked.xml"),Ingredient("mysterious_high_quality_metals", 5,"images/inventoryimages/mysterious_high_quality_metals.xml"),Ingredient("goldnugget", 10)},RECIPETABS.ROSE_TAB , TECH.CITY, RECIPE_GAME_TYPE.COMMON, "rose_chest_placer", 1.5)
      rose_chest.atlas = "images/inventoryimages/rose_chest.xml"
      rose_chest.sortkey = 17
	  


local rose_trash = Recipe("rose_trash",  {Ingredient("rose", 10,"images/inventoryimages/rose.xml"),Ingredient("livinglog", 5),Ingredient("alloy", 2)},RECIPETABS.ROSE_TAB , TECH.CITY, RECIPE_GAME_TYPE.COMMON, "rose_trash_placer", 1.5)
      rose_trash.atlas = "images/inventoryimages/rose_trash.xml"
      rose_trash.sortkey = 18
	  
	  


local rose_boomerang = Recipe("rose_boomerang",  {Ingredient("rose", 5,"images/inventoryimages/rose.xml"),Ingredient("livinglog", 2),Ingredient("silk", 5)},RECIPETABS.ROSE_TAB , TECH.CITY, RECIPE_GAME_TYPE.COMMON, nil, nil, nil)
      rose_boomerang.atlas = "images/inventoryimages/rose_boomerang.xml"
      rose_boomerang.sortkey = 20	
 


local firepit_rose = Recipe("firepit_rose",  {Ingredient("rose_worked", 5,"images/inventoryimages/rose_worked.xml"),Ingredient("livinglog",10)},RECIPETABS.ROSE_TAB , TECH.CITY, RECIPE_GAME_TYPE.COMMON, "firepit_rose_placer", 1.5)
      firepit_rose.atlas = "images/inventoryimages/firepit_rose.xml"
      firepit_rose.sortkey = 19

	  
	  
local rose_tool = Recipe("rose_tool",  {Ingredient("rose_worked", 10,"images/inventoryimages/rose_worked.xml"),Ingredient("livinglog",10),Ingredient("goldenaxe",1),Ingredient("goldenmachete",1),Ingredient("goldenpickaxe",1),Ingredient("goldenshovel",1),Ingredient("hammer",1)},RECIPETABS.ROSE_TAB , TECH.CITY, RECIPE_GAME_TYPE.COMMON,  nil, nil, nil)
      rose_tool.atlas = "images/inventoryimages/rose_tool.xml"
      rose_tool.sortkey = 21
	  
	  
	    
local tyrmask = Recipe("tyrmask",  {Ingredient("nightmarefuel", 20),Ingredient("trinket_14", 5),Ingredient("masks_fragment", 3,"images/inventoryimages/masks_fragment.xml"),Ingredient("honey", 3)},RECIPETABS.ROSE_TAB , TECH.CITY, RECIPE_GAME_TYPE.COMMON, nil, nil, nil)
      tyrmask.atlas = "images/inventoryimages/tyrmask.xml"
      tyrmask.sortkey = 13
	  
	  

local rosecrown = Recipe("rosecrown",  {Ingredient("rose", 20, "images/inventoryimages/rose.xml"),Ingredient("pigcrownhat", 1),Ingredient("pheromonestone", 1),Ingredient("coral_brain", 3)},RECIPETABS.ROSE_TAB , TECH.CITY, RECIPE_GAME_TYPE.COMMON, nil, nil, nil)
      rosecrown.atlas = "images/inventoryimages/rosecrown.xml"
      rosecrown.sortkey = 22  
	  
------------------------------------------------------------------------------------------------------SG-----------------------------------------------------------------------------------------------------------------------------	  

AddStategraphPostInit("wilson", function(sg) --修改SG
	
 local state_toolbroke = sg.states["toolbroke"]
 state_toolbroke.onenter = function(inst, tool)
 
      if tool then
       if not tool:HasTag("rose_tool") then
          inst.AnimState:PlayAnimation("hit")
		  inst.SoundEmitter:PlaySound("dontstarve/wilson/use_break")
		  inst.AnimState:Hide("ARM_carry") 
          inst.AnimState:Show("ARM_normal") 
	   end

	   if not tool:HasTag("rose_tool") then
          local brokentool = SpawnPrefab("brokentool")
          brokentool.Transform:SetPosition(inst.Transform:GetWorldPosition() )
	   end
	   
      else

        inst.AnimState:PlayAnimation("hit")
        inst.SoundEmitter:PlaySound("dontstarve/wilson/use_break")
        inst.AnimState:Hide("ARM_carry") 
        inst.AnimState:Show("ARM_normal") 
        local brokentool = SpawnPrefab("brokentool")
        brokentool.Transform:SetPosition(inst.Transform:GetWorldPosition() )	  
	   
	  end 
       inst.sg.statemem.tool = tool
       inst.toolwantstobreak = nil
 
 end
 state_toolbroke.onexit = function(inst)
 
    local sameTool = inst.components.inventory:FindItem(function(item)
    if inst.sg.statemem.tool then
       return item.prefab == inst.sg.statemem.tool.prefab
       end
	end)
    if sameTool then
	   inst.components.inventory:Equip(sameTool)
	end  
	if inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then
       inst.AnimState:Show("ARM_carry") 
       inst.AnimState:Hide("ARM_normal")
    end
 end
end)	



AddStategraphPostInit("wilsonboating", function(sg) --修改SG
	
 local state_toolbroke = sg.states["toolbroke"]
 state_toolbroke.onenter = function(inst, tool)
 
      if tool then
       if not tool:HasTag("rose_tool") then
          inst.AnimState:PlayAnimation("hit")
		  inst.SoundEmitter:PlaySound("dontstarve/wilson/use_break")
		  inst.AnimState:Hide("ARM_carry") 
          inst.AnimState:Show("ARM_normal") 
	   end

	   if not tool:HasTag("rose_tool") then
          local brokentool = SpawnPrefab("brokentool")
          brokentool.Transform:SetPosition(inst.Transform:GetWorldPosition() )
	   end
	   
      else

        inst.AnimState:PlayAnimation("hit")
        inst.SoundEmitter:PlaySound("dontstarve/wilson/use_break")
        inst.AnimState:Hide("ARM_carry") 
        inst.AnimState:Show("ARM_normal") 
        local brokentool = SpawnPrefab("brokentool")
        brokentool.Transform:SetPosition(inst.Transform:GetWorldPosition() )	  
	   
	  end 
       inst.sg.statemem.tool = tool
       inst.toolwantstobreak = nil
 
 end
 state_toolbroke.onexit = function(inst)
 
    local sameTool = inst.components.inventory:FindItem(function(item)
    if inst.sg.statemem.tool then
       return item.prefab == inst.sg.statemem.tool.prefab
       end
	end)
    if sameTool then
	   inst.components.inventory:Equip(sameTool)
	end  
	if inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) then
       inst.AnimState:Show("ARM_carry") 
       inst.AnimState:Hide("ARM_normal")
    end
 end
end)

--修改回旋镖
AddComponentPostInit("projectile",function(self)


 self.Stop = function(self)
 
     self.inst:StopUpdatingComponent(self)
     self.target = nil
     self.owner = nil
 
 end
  

 local old_Hit = self.Hit
 self.Hit = function(self, target)
   local attacker = self.owner
    local weapon = self.inst
    self:Stop()
	if weapon.prefab == "rose_boomerang" and not target:HasTag("player")  then
	
	
	      local smallScale = 0.5
          local medScale = 0.7
          local largeScale = 1.1
		  
          if target:HasTag("spider") then 
	   
        		local s = medScale
        		if target:HasTag("smallcreature") then
        			s = smallScale
    			elseif target:HasTag("largecreature") then
    				s = largeScale
    			end
        		local fx = SpawnPrefab("wathgrithr_spirit")
        		fx.Transform:SetPosition(target:GetPosition():Get())
        		fx.Transform:SetScale(s,s,s)
				fx.AnimState:SetMultColour(255/255,20/255,147/255,2)
				
				if target.components.combat then
				
				   target.components.combat:GetAttacked(GetPlayer(), TUNING.BOOMERANG_DAMAGE*2, weapon)
				
				end
				
				 if weapon.components.finiteuses then
				 
				    weapon.components.finiteuses.current = weapon.components.finiteuses.current + 2
					
					if weapon.components.finiteuses.current >= weapon.components.finiteuses.total then
					
					  weapon.components.finiteuses.current = weapon.components.finiteuses.total
					
					end
					
				 
				 end
				
	    else

        		local s = medScale
        		if target:HasTag("smallcreature") then
        			s = smallScale
    			elseif target:HasTag("largecreature") then
    				s = largeScale
    			end
        		local fx = SpawnPrefab("wathgrithr_spirit")
        		fx.Transform:SetPosition(target:GetPosition():Get())
        		fx.Transform:SetScale(s,s,s)	
				
       end
	  
    elseif weapon.prefab == "rose_boomerang" and target:HasTag("player") then
	
	   self.inst.Physics:Stop()
	   print(self.inst.prefab)
       print(self.inst.prefab)
	   print(self.inst.prefab)
	   
	else    

	   self.inst.Physics:Stop()
	   print(self.inst.prefab)
       print(self.inst.prefab)
	   print(self.inst.prefab)	
	   
	end
    if not attacker.components.combat and attacker.components.weapon and attacker.components.inventoryitem then
        weapon = attacker
        attacker = weapon.components.inventoryitem.owner
    end
    if attacker and attacker.components.combat then
        attacker.components.combat:DoAttack(target, weapon, self.inst)
    end
    
    if self.onhit then
        self.onhit(self.inst, attacker, target, weapon)
    end


 end
 


local old_OnUpdate = self.OnUpdate
self.OnUpdate = function(self, dt)
local target = self.target
    if self.homing and target and target:IsValid() and not target:IsInLimbo() then
        self.dest = Vector3(target.Transform:GetWorldPosition() )
    end
    local dest = self.dest
    local current = Vector3(self.inst.Transform:GetWorldPosition() )
    local direction = (dest - current):GetNormalized()
    local projectedSpeed = self.speed*TheSim:GetTickTime()*TheSim:GetTimeScale()
    local projected = current + direction*projectedSpeed
    local coveredDistSq = distsq(self.start, current)
    if self.range and coveredDistSq > self.range*self.range then
        self:Miss(target)
    elseif self.homing then
        if target and target:IsValid() and not target:IsInLimbo() and self.inst:IsNear(target, self.hitdist + (target.Physics and target.Physics:GetRadius() or 0)) then
            self:Hit(target)
        else
			if direction:Dot(dest - projected) < 0 then
				if target and target:IsValid() and not target:IsInLimbo() then
					self:Hit(target)
				else
					self:Miss(target)
				end
			else
				self:RotateToTarget(dest)
			end
		end  
    elseif self.vertical then 

        if target and target:IsValid() and not target:IsInLimbo() then 

            local myPos = Vector3(self.inst.Transform:GetWorldPosition())
            local targetPos = Vector3(target.Transform:GetWorldPosition())

            local vx, vy, vx = self.inst.Physics:GetVelocity()
            if vy < 0 then 
                myPos.x = targetPos.x
                myPos.z = targetPos.z 
                self.inst.Transform:SetPosition(myPos.x, myPos.y, myPos.z)
            end 

            if  myPos.y < 1 then 
                self:Hit(target)       
            end 
        else
            self.target = nil 
            if myPos.y < 1 then 
                self:Miss(target)       
            end 
        end 
     
    else
        -- WARNING: IsNear specifically excludes vertical distance
        local targ_rad = (target:IsValid() and target.Physics and target.Physics:GetRadius() or 0)
        if target and target:IsValid() and not target:IsInLimbo() and self.inst:IsNear(target, self.hitdist + targ_rad) then
            self:Hit(target)
        end
    end
 
 end
end)

end

--修改鸟可以交易
local function BirdsInit(inst)

  inst:AddComponent("tradable")

end

local birdslist = {

"crow",
"robin",
"robin_winter",
"parrot",
"parrot_pirate",
"toucan",
"seagull",
"seagull_water",
"pigeon",
"parrot_blue",
"kingfisher",
}

for i,v in pairs(birdslist) do


AddPrefabPostInit(v,BirdsInit)

end


--玫瑰之眼触发方法
local function SpawnRoseMonster(inst)

  local function onclose(inst)
  
    if not inst:HasTag("burnt") then
     inst.AnimState:PlayAnimation("close")
	 inst.SoundEmitter:PlaySound("dontstarve/wilson/chest_open")
	 
	  if GetWorld():HasTag("porkland") then
	     print("porkland")
	   if GetSeasonManager():IsAporkalypse() and not inst.interior then
	   print("IsAporkalypse & not interior")
	     local key = 0
	   
	     for k, v in pairs(inst.components.container.slots) do
		 
		  if  k ~= 5 and v.prefab == "rose" then
		  
		     key = key+1
		   
		  elseif k == 5 and v.prefab == "deerclops_eyeball" then

             key = key+1
			 
	      end
		  
         end
		 
		 print(key)
	
	   if key == 9 then
	     inst.components.container.canbeopened = false
		 inst.AnimState:PlayAnimation("hit")
		 inst.AnimState:PushAnimation("hit",true)

		 inst.task = inst:DoPeriodicTask(1,function()
		 	  inst.SoundEmitter:PlaySound("dontstarve/common/destroy_wood")		 
		    end)

		 
		 inst:DoTaskInTime(5,function()
		 
		   if inst.task then	
              inst.task:Cancel()
              inst.task = nil		  		
		   end
		   
           inst.components.container:DestroyContents()
           local item = SpawnPrefab("rose_amulet")
           inst.components.container:GiveItem(item)	
           inst.components.workable:Destroy(inst)		   
	     end)
		 
		 else
		 
		 return
	
	   end
	   
     end
	
	end
	
   end
   
 end
 
inst.components.container.onclosefn = onclose


end

AddPrefabPostInit("treasurechest",SpawnRoseMonster)


AddClassPostConstruct("widgets/bloodover",function(self)

local Old_OnUpdate = self.OnUpdate

self.OnUpdate = function(self,dt)

if GetPlayer():HasTag("eyeofrose") then
	   self.level = 0
	   self:Hide()
	return
	
	end
	
    if dt > 0.1 then return end
    
    local delta = self.base_level - self.level

    if math.abs(delta) < .025 then
        self.level = self.base_level
    else
        self.level = self.level + delta*dt*self.k
    end

    if self.base_level > 0 and not IsPaused() then
        self.time_since_pulse = self.time_since_pulse + dt
        if self.time_since_pulse > self.pulse_period then
            self.time_since_pulse = 0
            
            if not self.owner.components.health:IsDead() then
                TheInputProxy:AddVibration(VIBRATION_BLOOD_OVER, .2, .3, false)  
            end
        end
    end

    if self.level > 0 then
        self:Show()
        self.bg:SetTint(1,1,1,self.level)
    else
        self:StopUpdating()
        self:Hide()
    end



end



end)
modimport("scripts/foodtwo.lua")