require "prefabutil"

local assets =
{
    Asset("ANIM", "anim/firepit.zip"),
	Asset("ANIM", "anim/firepit_rose.zip"),
}

local prefabs =
{
    "campfirefire",
    "collapse_small",
	"rosefire",
}    

local function onhammered(inst, worker)
	inst.components.lootdropper:DropLoot()
	local ash = SpawnPrefab("ash")
	ash.Transform:SetPosition(inst.Transform:GetWorldPosition())
	SpawnPrefab("collapse_small").Transform:SetPosition(inst.Transform:GetWorldPosition())
	inst.SoundEmitter:PlaySound("dontstarve/common/destroy_stone")
	inst:Remove()
end

local function onhit(inst, worker)
	inst.AnimState:PlayAnimation("hit")
	inst.AnimState:PushAnimation("idle")
end

local function onignite(inst)
    if not inst.components.cooker then
        inst:AddComponent("cooker")
    end
end

local function onextinguish(inst)
    if inst.components.cooker then
        inst:RemoveComponent("cooker")
    end
end

local function test(inst,data)

if inst.components.container:Has("rose",4) then

  inst.SoundEmitter:PlaySound("dontstarve/common/fireAddFuel")
  if not inst.components.burnable:IsBurning() then
         inst.components.burnable:Ignite()
  end
  inst.components.burnable:SetFXLevel(4, 1)

elseif inst.components.container:Has("rose",3) then

  inst.SoundEmitter:PlaySound("dontstarve/common/fireAddFuel")
  if not inst.components.burnable:IsBurning() then
         inst.components.burnable:Ignite()
  end
  inst.components.burnable:SetFXLevel(3, .75)

elseif inst.components.container:Has("rose",2) then

  inst.SoundEmitter:PlaySound("dontstarve/common/fireAddFuel")
  if not inst.components.burnable:IsBurning() then
         inst.components.burnable:Ignite()
  end
  inst.components.burnable:SetFXLevel(2, .5)

elseif inst.components.container:Has("rose",1) then

  inst.SoundEmitter:PlaySound("dontstarve/common/fireAddFuel")
  if not inst.components.burnable:IsBurning() then
         inst.components.burnable:Ignite()
  end
  inst.components.burnable:SetFXLevel(1, .25)

else

  if inst.components.burnable:IsBurning() then
     inst.components.burnable:Extinguish()
  end
  inst.components.burnable:SetFXLevel(0, 0)

end
end
local slotpos = {}

for y = 0, 3 do
	table.insert(slotpos, Vector3(-162 +(75/2), -y*75 + 114, 0))
end
	
local function itemtest(inst, item, slot)
	
	return item.prefab == "rose"
	
end

local function noextinguish()


end

local function itemtest(inst, item, slot)
	return item.prefab == "rose"
end

local function fn(Sim)

	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
	local minimap = inst.entity:AddMiniMapEntity()
	minimap:SetIcon( "firepit.png" )
	minimap:SetPriority( 1 )

    anim:SetBank("firepit_rose")
    anim:SetBuild("firepit_rose")
    anim:PlayAnimation("idle",false)
    inst:AddTag("campfire")
    inst:AddTag("structure")
	inst:AddTag("firepit_rose")
  
    MakeObstaclePhysics(inst, .3)    

    -----------------------
    inst:AddComponent("burnable")
    --inst.components.burnable:SetFXLevel(2)
    inst.components.burnable:AddBurnFX("rosefire", Vector3(0,.5,0) )
    inst.components.burnable:MakeNotWildfireStarter()
    inst:ListenForEvent("onextinguish", onextinguish)
    inst:ListenForEvent("onignite", onignite)
    -------------------------
    inst:AddComponent("lootdropper")
    inst:AddComponent("workable")
    inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
    inst.components.workable:SetWorkLeft(4)
	inst.components.workable:SetOnFinishCallback(onhammered)
	inst.components.workable:SetOnWorkCallback(onhit)    

    inst:AddComponent("container")
	inst.components.container.itemtestfn = itemtest
	inst.components.container:SetNumSlots(#slotpos, true)
	inst.components.container.widgetslotpos = slotpos
	inst.components.container.widgetpos = Vector3(75, 200, 0)
	inst.components.container.widgetanimbank = "ui_thatchpack_1x4"
    inst.components.container.widgetanimbuild = "ui_thatchpack_1x4"
    inst.components.container.side_align_tip = 160
    inst.components.container.acceptsstacks = false
    inst.components.burnable.LongUpdate = noextinguish
    
    inst:ListenForEvent( "onbuilt", function()
        anim:PlayAnimation("place")
        anim:PushAnimation("idle",false)
        inst.SoundEmitter:PlaySound("dontstarve/common/fireAddFuel")
    end)
	
	inst:ListenForEvent( "itemget", test)
	inst:ListenForEvent( "itemlose", test)
	test(inst)
    
    return inst
end

return Prefab( "common/objects/firepit_rose", fn, assets, prefabs),
		MakePlacer( "common/firepit_rose_placer", "firepit_rose", "firepit_rose", "preview" ) 
