local assets=
{
	Asset("ANIM", "anim/rose_boomerang.zip"),
	Asset("ANIM", "anim/swap_rose_boomerang.zip"),
    Asset( "IMAGE", "images/inventoryimages/rose_boomerang.tex" ),
    Asset( "ATLAS", "images/inventoryimages/rose_boomerang.xml" ),
}



    
local prefabs =
{
}

local function OnFinished(inst)
    inst.AnimState:PlayAnimation("used")
    inst:ListenForEvent("animover", function() inst:Remove() end)
end

local function OnEquip(inst, owner) 
    owner.AnimState:OverrideSymbol("swap_object", "swap_rose_boomerang", "swap_boomerang")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
end

local function OnHitOwner(inst)
    inst.components.floatable:SetAnimationFromPosition()
	inst.primarytarget = nil
end

local function OnUnequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end

local function OnThrown(inst, owner, target)
    if target ~= owner then
       owner.SoundEmitter:PlaySound("dontstarve/wilson/boomerang_throw")
	   if not inst.primarytarget then	
	   inst.primarytarget = target.prefab
	   end
	end   
    inst.AnimState:PlayAnimation("spin_loop", true)
end

local function OnCaught(inst, catcher)
    if catcher then
        if catcher.components.inventory then
            if inst.components.equippable and not catcher.components.inventory:GetEquippedItem(inst.components.equippable.equipslot) then
				catcher.components.inventory:Equip(inst)
			else
                catcher.components.inventory:GiveItem(inst)
            end
            catcher:PushEvent("catch")
		    inst.primarytarget = nil
        end
    end
end

local function ReturnToOwner(inst, owner)
    if owner and not (inst.components.finiteuses and inst.components.finiteuses:GetUses() < 1) then
        owner.SoundEmitter:PlaySound("dontstarve/wilson/boomerang_return")
		 local cruxtarget = FindEntity(inst, 15, function(guy) 
         if guy.components.combat and guy.components.health and not guy.components.health:IsDead() and not guy:HasTag("player") and not guy:HasTag("hited")and not guy:HasTag("gnat") and not guy:HasTag("wall") and not guy:HasTag("invalidtarget") and not guy:HasTag("invalidtarget")and not guy:HasTag("falling")and not guy:HasTag("FX")and not guy:HasTag("NOCLICK")and not guy:HasTag("DECOR") and not guy:HasTag("INLIMBO") and not guy:HasTag("spiderden") and not guy:HasTag("chester") and not guy:HasTag("girlfriend") and not guy:HasTag("companion") then
               
			 if guy:HasTag("monster")then
			   
			   if guy.components.follower and guy.components.follower.leader then
			   
			      return (guy.components.combat.target == owner or owner.components.combat.target == guy or not guy:HasTag("hited")) and not guy.components.follower.leader:HasTag("player") and guy:HasTag("monster")
				  
				else

                 return (guy.components.combat.target == owner or owner.components.combat.target == guy or not guy:HasTag("hited") )and guy:HasTag("monster")
				
				end 
            else

              if inst.primarytarget then 
			  
			    if guy.components.follower and guy.components.follower.leader then
			   
			      return (guy.components.combat.target == owner or owner.components.combat.target == guy or not guy:HasTag("hited")) and not guy.components.follower.leader:HasTag("player") and guy.prefab == inst.primarytarget
				  
				else

                 return (guy.components.combat.target == owner or owner.components.combat.target == guy or not guy:HasTag("hited"))and guy.prefab == inst.primarytarget	
				 
                end 
				
			  else
			  
			  	if guy.components.follower and guy.components.follower.leader then
              
			  	  return (guy.components.combat.target == owner or owner.components.combat.target == guy or not guy:HasTag("hited")) and not guy.components.follower.leader:HasTag("player") 
				  
				else

                 return (guy.components.combat.target == owner or owner.components.combat.target == guy or not guy:HasTag("hited"))
				 
                end 
			  
			  end			  
			end
		end	
      end )
		
		if cruxtarget then
           inst.components.projectile:Throw(owner, cruxtarget)
        else
           inst.components.projectile:Throw(owner, owner)
		   inst.primarytarget = nil
        end

    end
end

local function OnHit(inst, owner, target)
    if owner == target then
        OnHitOwner(inst)
    else
	    target:AddTag("hited")
        ReturnToOwner(inst, owner)
	    target:RemoveTag("hited")
    end
    local impactfx = SpawnPrefab("impact")
    if impactfx then
	    local follower = impactfx.entity:AddFollower()
	    follower:FollowSymbol(target.GUID, target.components.combat.hiteffectsymbol, 0, 0, 0 )
        impactfx:FacePoint(inst.Transform:GetWorldPosition())
    end
end


local function onsave(inst, data)

    if inst.primarytarget then
       data.primarytarget = inst.primarytarget
    end
	
end



local function onload(inst, data)

    if data.primarytarget then
       inst.primarytarget = data.primarytarget
    end


end

local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst .entity:AddTransform()
	local anim = inst.entity:AddAnimState()
    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)
    
    anim:SetBank("rose_boomerang")
    anim:SetBuild("rose_boomerang")
    anim:PlayAnimation("idle")
    anim:SetRayTestOnBB(true)
	inst.Transform:SetScale(.5, .5, .5)
    
    MakeInventoryFloatable(inst, "idle_water", "idle")
    
    inst:AddTag("projectile")
    inst:AddTag("thrown")
	
	inst.primarytarget = nil
    
    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(TUNING.BOOMERANG_DAMAGE*2)
    inst.components.weapon:SetRange(TUNING.BOOMERANG_DISTANCE, TUNING.BOOMERANG_DISTANCE+2)
    -------
    
    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(100)
    inst.components.finiteuses:SetUses(100)
    
    inst.components.finiteuses:SetOnFinished(OnFinished)

    inst:AddComponent("inspectable")
	
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.imagename = "rose_boomerang"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/rose_boomerang.xml" 
    inst.components.inventoryitem.foleysound = "dontstarve/movement/foley/jewlery"
	
    inst:AddComponent("projectile")
    inst.components.projectile:SetSpeed(20)
    inst.components.projectile:SetCanCatch(true)
    inst.components.projectile:SetOnThrownFn(OnThrown)
    inst.components.projectile:SetOnHitFn(OnHit)
    inst.components.projectile:SetOnMissFn(ReturnToOwner)
    inst.components.projectile:SetOnCaughtFn(OnCaught)
    inst.components.projectile:SetLaunchOffset(Vector3(0, 0.2, 0))

	
	inst:ListenForEvent("onthrown", function(inst)
        local pt = inst:GetPosition()
        inst.Transform:SetPosition(pt.x, 2, pt.z)
        inst.SoundEmitter:PlaySound("dontstarve/wilson/boomerang_throw")
    end)
	
    
    
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip(OnEquip)
    inst.components.equippable:SetOnUnequip(OnUnequip)
	
	
	inst.OnSave = onsave
    inst.OnLoad = onload
    
    return inst
end

return Prefab( "common/inventory/rose_boomerang", fn, assets) 
