
local assets=
{
	Asset("ANIM", "anim/rose_chest.zip"),
    Asset("ANIM", "anim/ui_chest_5x16.zip"),
}

local prefabs =
{
	"collapse_small",
	"rose_chestlight",
}

local function onopen(inst) 
	inst.AnimState:PlayAnimation("open") 
	inst.SoundEmitter:PlaySound("dontstarve/wilson/chest_open")
	inst.chestlight = SpawnPrefab("rose_chestlight")
	if CHESTSOUND then
	   inst.SoundEmitter:PlaySound("dontstarve/creatures/chester/raise","raise")
    end
	
	inst.chestlight.Transform:SetPosition(inst:GetPosition():Get())
    inst.chestlight:TurnOn()
end 

local function onclose(inst)
	inst.AnimState:PlayAnimation("close") 
	inst.SoundEmitter:PlaySound("dontstarve/wilson/chest_close")
	if CHESTSOUND then
       inst.SoundEmitter:KillSound("raise")
	end
	if inst.chestlight then
	   inst.chestlight:TurnOff()
	   inst.chestlight:Remove()
	end   
end 

local function onhammered(inst, worker)
	inst.components.lootdropper:DropLoot()
	if inst.components.container then inst.components.container:DropEverything() end
	SpawnPrefab("collapse_small").Transform:SetPosition(inst.Transform:GetWorldPosition())
	inst.SoundEmitter:PlaySound("dontstarve/common/destroy_wood")	
	inst:Remove()

end

local function onhit(inst, worker)
	inst.AnimState:PlayAnimation("hit")
	inst.AnimState:PushAnimation("closed", false)
	if inst.components.container then 
		inst.components.container:DropEverything() 
		inst.components.container:Close()
	end
end

local function onbuilt(inst)
	inst.AnimState:PlayAnimation("place")
	inst.AnimState:PushAnimation("closed", false)
	inst.SoundEmitter:PlaySound("dontstarve_DLC001/common/craftable/dragonfly_chest")
end

local slotpos = {}
for y = 4, 0, -1 do
	for x = 0, 15 do
	table.insert(slotpos, Vector3(80*x-346*2+91, 80*y-100*2+42,0))
	end
end

local widgetbuttoninfo = {
    text = "Give",
    position = Vector3(0, -210, 0),
    fn = function(inst)
	     for k,v in pairs(GetPlayer().components.inventory.itemslots) do
		    if inst.components.container:Has(v.prefab,1) then
			    if v.components.stackable then				
				   if not inst.components.container:IsFull() then				   
				      inst.components.container:GiveItem(GetPlayer().components.inventory:RemoveItemBySlot(k),nil, Vector3(TheSim:GetScreenPos(GetPlayer().Transform:GetWorldPosition())))					  
				   elseif inst.components.container:IsFull() then				      
					  for i,l in pairs(inst.components.container.slots) do
                          local other_item = inst.components.container.slots[i]
						  if other_item and other_item.prefab == v.prefab and not other_item.components.stackable:IsFull() then
						     local leftsize = other_item.components.stackable.maxsize - other_item.components.stackable.stacksize
							 print(leftsize)
						  	  if leftsize >= v.components.stackable.stacksize then							  
                                 inst.components.container:GiveItem(GetPlayer().components.inventory:RemoveItemBySlot(k),nil, Vector3(TheSim:GetScreenPos(GetPlayer().Transform:GetWorldPosition())))						  							  
							  else							  
							      for i = 1 ,leftsize do							  
									  local item = GetPlayer().components.inventory:RemoveItem(GetPlayer().components.inventory.itemslots[k].components.stackable:Get(),nil,Vector3(TheSim:GetScreenPos(GetPlayer().Transform:GetWorldPosition())))
									  inst.components.container:GiveItem(item)
							      end								  
							 end
						  end                       
				      end					  					  
				   end			
				elseif not v.components.stackable then
				       if not inst.components.container:IsFull() then					   
					     inst.components.container:GiveItem(GetPlayer().components.inventory:RemoveItemBySlot(k),nil, Vector3(TheSim:GetScreenPos(GetPlayer().Transform:GetWorldPosition())))						 
					   end
	            end		
			end  
         end
		 		 
        if GetPlayer().components.inventory.overflow and GetPlayer().components.inventory.overflow.components.container then
            for k,v in pairs(GetPlayer().components.inventory.overflow.components.container.slots) do
			    if inst.components.container:Has(v.prefab,1) then				   				   
				  if v.components.stackable then				
				   if not inst.components.container:IsFull() then				   
				      inst.components.container:GiveItem(GetPlayer().components.inventory.overflow.components.container:RemoveItemBySlot(k),nil, Vector3(TheSim:GetScreenPos(GetPlayer().Transform:GetWorldPosition())))					  
				   elseif inst.components.container:IsFull() then				      
					  for i,l in pairs(inst.components.container.slots) do
                          local other_item = inst.components.container.slots[i]
						  if other_item and other_item.prefab == v.prefab and not other_item.components.stackable:IsFull() then
						     local leftsize = other_item.components.stackable.maxsize - other_item.components.stackable.stacksize
						  	  if leftsize >= v.components.stackable.stacksize then							  
                                 inst.components.container:GiveItem(GetPlayer().components.inventory.overflow.components.container:RemoveItemBySlot(k),nil, Vector3(TheSim:GetScreenPos(GetPlayer().Transform:GetWorldPosition())))						  							  
							  else							  
							      for i = 1 ,leftsize do							  
									  local item = GetPlayer().components.inventory.overflow.components.container:RemoveItem(GetPlayer().components.inventory.overflow.components.container.slots[k].components.stackable:Get(),nil,Vector3(TheSim:GetScreenPos(GetPlayer().Transform:GetWorldPosition())))
									  inst.components.container:GiveItem(item)
							      end								  
							 end
						  end                       
				      end					  					  
				   end						   
				elseif not v.components.stackable then
				    if not inst.components.container:IsFull() then					   
					   inst.components.container:GiveItem(GetPlayer().components.inventory.overflow.components.container:RemoveItemBySlot(k),nil, Vector3(TheSim:GetScreenPos(GetPlayer().Transform:GetWorldPosition())))						 
					end
	            end				   
		     end  			
          end
      end

	 inst.SoundEmitter:PlaySound("dontstarve/HUD/collect_resource")		
end}

		
local function fn()
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	local minimap = inst.entity:AddMiniMapEntity()	
	minimap:SetIcon("dragonflychest.png")

	local s = 1
	inst.Transform:SetScale(s,s,s)
	inst:AddTag("nodestroy")
	inst:AddTag("structure")
	inst:AddTag("chest")
	inst.AnimState:SetBank("dragonfly_chest")
	inst.AnimState:SetBuild("rose_chest")
	inst.AnimState:PlayAnimation("closed")
	
	inst:AddComponent("inspectable")
	inst:AddComponent("container")
	inst.components.container:SetNumSlots(#slotpos)
	
	inst.components.container.onopenfn = onopen
	inst.components.container.onclosefn = onclose
	
	inst.components.container.widgetslotpos = slotpos
    inst.components.container.widgetanimbank = "ui_chest_5x16"
    inst.components.container.widgetanimbuild = "ui_chest_5x16"	
    inst.components.container.widgetpos = Vector3(0,200,0)
	inst.components.container.side_align_tip = 160
	inst.components.container.widgetbuttoninfo = widgetbuttoninfo
	
	inst:AddComponent("lootdropper")
	inst:AddComponent("workable")
	inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
	inst.components.workable:SetWorkLeft(30)
	inst.components.workable:SetOnFinishCallback(onhammered)
	inst.components.workable:SetOnWorkCallback(onhit) 
	
	inst:ListenForEvent( "onbuilt", onbuilt)
	MakeSnowCovered(inst, .01)	
	
	if inst.chestlight then 
	   inst.chestlight:TurnOff()
	   inst.chestlight:Remove()
    end
	
	if TUNING.SMART_SIGN_DRAW_ENABLE then
       SMART_SIGN_DRAW(inst)
    end
	
	return inst
end

return Prefab( "common/rose_chest", fn, assets),
		MakePlacer("rose_chest_placer", "dragonfly_chest", "rose_chest", "closed")