local assets=
{
	Asset("ANIM", "anim/rose_tool.zip"),
    Asset("ANIM", "anim/swap_rose_tool.zip"),
    Asset("ANIM", "anim/swap_rose_tool_dig.zip"),
}

local prefabs = 
{
    "rose_worked"
}

local function onfinished(inst)


	inst:RemoveComponent("tool")	
    inst:PushEvent("lostrequirement")
	inst:RemoveTag("getrequirement")


end

local function checkactions(inst, owner)

    if owner.bufferedaction and owner.bufferedaction.action and owner.bufferedaction.action == ACTIONS.DIG then

       owner.AnimState:OverrideSymbol("swap_object", "swap_rose_tool_dig", "swap_rose_tool_dig")
	else
	  	owner.AnimState:OverrideSymbol("swap_object", "swap_rose_tool", "swap_rose_tool") 
    end
end


local function onequip(inst, owner)

    owner.AnimState:OverrideSymbol("swap_object", "swap_rose_tool", "swap_rose_tool") 
	owner.AnimState:Show("ARM_carry")
	owner.AnimState:Hide("ARM_normal")
	inst.task = inst:DoPeriodicTask(FRAMES, function() checkactions(inst, owner) end)

end

local function onunequip(inst, owner)

	inst.task:Cancel()
	inst.task = nil
	
	owner.AnimState:ClearOverrideSymbol("swap_object")
	owner.AnimState:Hide("ARM_carry")
	owner.AnimState:Show("ARM_normal")
	

end

local function ShouldAcceptItem(inst, item)
    local player = GetPlayer()
    if player.components.inventory:Has("rose_worked", 1) then
       if item.prefab == "rose_worked" then
        return true
        end
    end
    return false
end


local function OnGetItemFromPlayer(inst, giver, item)
    if item.prefab == "rose_worked" then
	   inst.components.finiteuses.current = inst.components.finiteuses.current + inst.components.finiteuses.total * 0.20
	   if inst.components.finiteuses.current > inst.components.finiteuses.total then
	      inst.components.finiteuses.current = inst.components.finiteuses.total
	   end
	   if inst.components.finiteuses.current > 0 then
	      inst:AddComponent("tool")
	      inst.components.tool:SetAction(ACTIONS.CHOP,3)
          inst.components.tool:SetAction(ACTIONS.MINE,3)
          inst.components.tool:SetAction(ACTIONS.HACK,3)	
          inst.components.tool:SetAction(ACTIONS.HAMMER,3)
          inst.components.tool:SetAction(ACTIONS.DIG,3)
		  inst:PushEvent("getrequirement")
	      inst:AddTag("getrequirement")
	   end
	   inst:PushEvent("percentusedchange", {percent = inst.components.finiteuses:GetPercent()}) 
    end
end

local function fn(Sim)
    
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	inst.entity:AddPhysics()
    MakeInventoryPhysics(inst)
    MakeInventoryFloatable(inst, "idle_water", "idle")
    inst.Transform:SetScale(2, 2, 2)
		
    inst.AnimState:SetBank("rose_tool")
    inst.AnimState:SetBuild("rose_tool")
    inst.AnimState:PlayAnimation("idle")
	inst:AddTag("nopunch")
	inst:AddTag("rose_tool")	 
    inst:AddTag("hammer")	
    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.imagename = "rose_tool"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/rose_tool.xml"
	
		
	--inst:AddComponent("weapon")
    --inst.components.weapon:SetDamage(1)
	
	inst:AddComponent("finiteuses")	
	inst.components.finiteuses:SetMaxUses(100)
	inst.components.finiteuses:SetUses(100)
	inst.components.finiteuses:SetOnFinished( onfinished) 
	inst.components.finiteuses:SetConsumption(ACTIONS.CHOP, 1)
	inst.components.finiteuses:SetConsumption(ACTIONS.MINE, 1)	
	inst.components.finiteuses:SetConsumption(ACTIONS.DIG, 1)
	inst.components.finiteuses:SetConsumption(ACTIONS.HACK, 1)
	inst.components.finiteuses:SetConsumption(ACTIONS.HAMMER, 1)
	
	if inst.components.finiteuses.current and inst.components.finiteuses.current > 0 then
	   inst:AddComponent("tool")
	   inst.components.tool:SetAction(ACTIONS.CHOP,3)
       inst.components.tool:SetAction(ACTIONS.MINE,3)
       inst.components.tool:SetAction(ACTIONS.HACK,3)	
       inst.components.tool:SetAction(ACTIONS.HAMMER,3)
       inst.components.tool:SetAction(ACTIONS.DIG,3)
	   inst:PushEvent("getrequirement")
	   inst:AddTag("getrequirement")
	else
	   inst:PushEvent("lostrequirement")
	   inst:RemoveTag("getrequirement")
	end
	
	inst:AddComponent("equippable")
	inst.components.equippable:SetOnEquip(onequip)
	inst.components.equippable:SetOnUnequip(onunequip)
	
	inst:AddComponent("trader")
    inst.components.trader.onaccept = OnGetItemFromPlayer
    inst.components.trader:SetAcceptTest(ShouldAcceptItem)
 
    return inst
end

return Prefab( "common/inventory/rose_tool", fn, assets,prefabs) 
