
local assets=
{
	Asset("ANIM", "anim/rose_trash.zip"),
    Asset("ANIM", "anim/ui_chest_5x16.zip"),
}

local prefabs =
{
	"collapse_small",
}

local function onopen(inst) 
	inst.AnimState:PlayAnimation("opened") 
	inst.SoundEmitter:PlaySound("dontstarve_DLC003/common/crafted/cork_chest/open")

end 

local function onclose(inst)
	inst.AnimState:PlayAnimation("closed") 
    inst.SoundEmitter:PlaySound("dontstarve_DLC003/common/crafted/cork_chest/close")
 
end 

local function onhammered(inst, worker)
	inst.components.lootdropper:DropLoot()
	if inst.components.container then inst.components.container:DropEverything() end
	SpawnPrefab("collapse_small").Transform:SetPosition(inst.Transform:GetWorldPosition())
	inst.SoundEmitter:PlaySound("dontstarve/common/destroy_wood")	
	inst:Remove()

end

local function onhit(inst, worker)
	inst.AnimState:PlayAnimation("hit")
	inst.AnimState:PushAnimation("closed", false)
	if inst.components.container then 
		inst.components.container:DropEverything() 
		inst.components.container:Close()
	end
end

local function onbuilt(inst)
	inst.AnimState:PlayAnimation("onbuild")
	inst.AnimState:PushAnimation("closed", false)
	inst.SoundEmitter:PlaySound("dontstarve_DLC001/common/craftable/dragonfly_chest")
end

local slotpos = {}

for y = 2, 0, -1 do
    for x = 0, 2 do
        table.insert(slotpos, Vector3(80*x-80*2+80, 80*y-80*2+80,0))
    end
end

local widgetbuttoninfo = {
    text = "Destroy",
    position = Vector3(0, -145, 0),
    fn = function(inst)
	     local num = 0
	     for k,v in pairs(inst.components.container.slots) do
              if v.components.stackable then
			     for k = 1, v.components.stackable.stacksize do
				     GetPlayer().components.sanity:DoDelta(1)
					 num = num +1
					 v:Remove()
				 end
			  else
                    GetPlayer().components.sanity:DoDelta(1)
		            num = num +1
					v:Remove()
              end
         end
		 GetPlayer().components.talker:Say("Sanity Increase("..num..")", 6, false)
         inst.SoundEmitter:PlaySound("dontstarve/common/destroy_stone")
		
    end }


		
local function fn()
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	local minimap = inst.entity:AddMiniMapEntity()	
	minimap:SetIcon("dragonflychest.png")

	local s = 1
	inst.Transform:SetScale(s,s,s)
	inst:AddTag("quickperish")
	inst:AddTag("structure")
	inst:AddTag("chest")
	inst.AnimState:SetBank("rose_trash")
	inst.AnimState:SetBuild("rose_trash")
	inst.AnimState:PlayAnimation("closed")
	
	inst:AddComponent("inspectable")
	inst:AddComponent("container")
	inst.components.container:SetNumSlots(#slotpos)
	
	inst.components.container.onopenfn = onopen
	inst.components.container.onclosefn = onclose
	
	inst.components.container.widgetslotpos = slotpos
    inst.components.container.widgetanimbank = "ui_chest_3x3"
    inst.components.container.widgetanimbuild = "ui_chest_3x3"	
    inst.components.container.widgetpos = Vector3(0,220,0)
    inst.components.container.side_align_tip = 160
    inst.components.container.widgetbuttoninfo = widgetbuttoninfo	
	
	inst:AddComponent("lootdropper")
	inst:AddComponent("workable")
	inst.components.workable:SetWorkAction(ACTIONS.HAMMER)
	inst.components.workable:SetWorkLeft(10)
	inst.components.workable:SetOnFinishCallback(onhammered)
	inst.components.workable:SetOnWorkCallback(onhit) 
	
	inst:ListenForEvent( "onbuilt", onbuilt)
	MakeSnowCovered(inst, .01)	

	return inst
end

return Prefab( "common/rose_trash", fn, assets),
		MakePlacer("common/rose_trash_placer", "rose_trash", "rose_trash", "closed")