local assets=
{
	Asset("ANIM", "anim/rosecrown.zip"),
    Asset("ANIM", "anim/rosecrown_ground.zip"),
	Asset( "IMAGE", "images/inventoryimages/rosecrown.tex" ),
    Asset( "ATLAS", "images/inventoryimages/rosecrown.xml" ),
}

local prefabs =
{
	"rose_chestlight",
}


local function onequip(inst, owner)

		owner.AnimState:OverrideSymbol("swap_hat", "rosecrown", "swap_hat")
		owner.AnimState:Show("HAT")
		owner.AnimState:Show("HAIR_HAT")
		owner.AnimState:Hide("HAIR_NOHAT")
		owner.AnimState:Hide("HAIR")

		if owner:HasTag("player") then
		  owner.AnimState:Hide("HEAD")
		  owner.AnimState:Show("HEAD_HAIR")
		  owner.AnimState:Hide("HAIRFRONT")
		end
		

		inst.buildertest = function()  
		  if owner.components.hunger.current >= 10 then			 
			    owner.components.builder.jellybrainhat = true
		        owner:PushEvent("techlevelchange")
    	        owner:PushEvent("unlockrecipe")				
	      else			 
			    owner.components.builder.jellybrainhat = false	
		        owner:PushEvent("techlevelchange")
    	        owner:PushEvent("unlockrecipe")					
	      end
		end   		   

		
		if not inst.chestlight then
           inst.chestlight = SpawnPrefab("rose_chestlight")
		   owner:AddChild(inst.chestlight)
           inst.chestlight:TurnOn()		   
		end

		
		owner:AddTag("antlingual")
		
		inst.brainjelly_onbuild = function()
		
		  if owner.components.hunger.current >= 10 then
    		owner.components.sanity:DoDelta(3)
			owner.components.hunger:DoDelta(-10)
		  end
		  
    	end
		
		inst.buildertest()
		
		if owner.components.builder then
		   owner:ListenForEvent("builditem", inst.brainjelly_onbuild)
    	   owner:ListenForEvent("bufferbuild", inst.brainjelly_onbuild)
		   owner:ListenForEvent("hungerdelta", inst.buildertest) 
		end
		

		
end

local function onunequip(inst, owner)

		owner.AnimState:Hide("HAT")
		owner.AnimState:Hide("HAIR_HAT")
		owner.AnimState:Show("HAIR_NOHAT")
		owner.AnimState:Show("HAIR")

		if owner:HasTag("player") then
			owner.AnimState:Show("HEAD")
			owner.AnimState:Hide("HEAD_HAIR")
			owner.AnimState:Show("HAIRFRONT")
		end
		
		if inst.task then
		   inst.task:Cancel()
		   inst.task = nil
		end
		
		if inst.chestlight then
		   inst.chestlight:TurnOff()
	       owner:RemoveChild(inst.chestlight)
           inst.chestlight:Remove()
           inst.chestlight= nil
        end	
		
		owner:RemoveTag("antlingual")
		
		if owner.components.builder then
		   owner.components.builder.jellybrainhat = false
		   owner:PushEvent("techlevelchange")
    	   owner:PushEvent("unlockrecipe")
		   owner:RemoveEventCallback("builditem", inst.brainjelly_onbuild)
		   owner:RemoveEventCallback("bufferbuild", inst.brainjelly_onbuild)
		   owner:RemoveEventCallback("hungerdelta", inst.buildertest)
		   inst.brainjelly_onbuild = nil
		   inst.buildertest = nil
		end
		

		
end

local function fn(Sim)
    
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	inst.entity:AddPhysics()
    MakeInventoryPhysics(inst)
	inst.AnimState:PlayAnimation("idle")
    MakeInventoryFloatable(inst, "idle_water", "idle")

	inst.AnimState:SetBloomEffectHandle( "shaders/anim.ksh" )
	
    inst.AnimState:SetBank("rosecrown_ground")
    inst.AnimState:SetBuild("rosecrown_ground")
	
	inst:AddTag("hat")
  
    inst:AddComponent("inspectable")
	
	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.imagename = "rosecrown"
    inst.components.inventoryitem.atlasname = "images/inventoryimages/rosecrown.xml"    
	
	inst:AddComponent("equippable")
	inst.components.equippable.equipslot = EQUIPSLOTS.HEAD
    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)

    return inst
end

return Prefab( "common/inventory/rosecrown", fn, assets) 
