local assets=
{
    Asset("ANIM", "anim/tyrmask.zip"),
	Asset( "IMAGE", "images/inventoryimages/tyrmask.tex" ),
    Asset( "ATLAS", "images/inventoryimages/tyrmask.xml" ),	
}

local function test(inst)
    if not inst.components.fueled:IsEmpty() then
	   
       inst:PushEvent("getrequirement")
	   inst:AddTag("getrequirement")
	   
     else
	 
       inst:PushEvent("lostrequirement")
	   inst:RemoveTag("getrequirement")
	   
     end

end

local function setdepleted(inst)
   local owner = inst.components.inventoryitem and inst.components.inventoryitem.owner
   	-- if MASKSOUND then
    -- owner.SoundEmitter:KillSound("tyrmask")
    -- end	
   	inst:PushEvent("lostrequirement")
	inst:RemoveTag("getrequirement")
	
    if inst.components.equippable:IsEquipped() then
	
	owner:RemoveTag("godofwar")
	owner.Transform:SetScale(1, 1, 1)	
	if inst.fire then
	  inst.fire:Remove()
      inst.fire = nil
	end  
		
	end

end

local function ontakefuel(inst)
   local owner = inst.components.inventoryitem and inst.components.inventoryitem.owner
    if inst.components.equippable:IsEquipped() then

       inst.components.fueled:StartConsuming()
	   
	   owner:AddTag("godofwar")
	   owner.Transform:SetScale(1.2, 1.2, 1.2)
		
	   if not inst.fire then
	
	      inst.fire = SpawnPrefab( "campfirefire" )
          local follower = inst.fire.entity:AddFollower()
          follower:FollowSymbol( owner.GUID, "swap_hat", -6, -280, 0 )
          inst.fire.AnimState:SetMultColour(255/255,0/255,0/255,1)
          inst.fire.Transform:SetScale(1.5, 1.5, 1.5)
          inst.fire:RemoveComponent("heater")
		  inst.fire:AddTag("FX")
	      inst.fire:AddTag("INTERIOR_LIMBO_IMMUNE")
          inst.fire.persists = false
		
	    end
	   
	   -- if MASKSOUND then
	   -- owner.SoundEmitter:PlaySound("mask/mask/rose_money", "tyrmask")
	   -- end


    end
	inst:PushEvent("getrequirement")
	inst:AddTag("getrequirement")	
	
end


local function onequip(inst, owner)
	owner.AnimState:OverrideSymbol("swap_hat", "tyrmask", "swap_hat")
	owner.AnimState:Show("HAT")
	owner.AnimState:Hide("HAT_HAIR")
	owner.AnimState:Show("HAIR_NOHAT")
	owner.AnimState:Show("HAIR")
	
	owner.AnimState:Show("HEAD")
	owner.AnimState:Hide("HEAD_HAIR")
	
	inst.components.fueled:StartConsuming()
	
	if not inst.components.fueled:IsEmpty() then
	
	owner:AddTag("godofwar")
	owner.Transform:SetScale(1.2, 1.2, 1.2)	
	
	if not inst.fire then
	
	    inst.fire = SpawnPrefab( "campfirefire" )
        local follower = inst.fire.entity:AddFollower()
        follower:FollowSymbol( owner.GUID, "swap_hat", -6, -280, 0 )
        inst.fire.AnimState:SetMultColour(255/255,0/255,0/255,1)
        inst.fire.Transform:SetScale(1.5, 1.5, 1.5)
        inst.fire:RemoveComponent("heater")
		inst.fire:AddTag("FX")
	    inst.fire:AddTag("INTERIOR_LIMBO_IMMUNE")
        inst.fire.persists = false
		
	end

	   -- if MASKSOUND then
       -- owner.SoundEmitter:PlaySound("mask/mask/rose_money", "tyrmask")
	   -- end
	   

    end
	
	if inst.components.fueled:IsEmpty() then
   	    inst:PushEvent("lostrequirement")
	    inst:RemoveTag("getrequirement")
    end

end
local function onunequip(inst, owner)
	owner.AnimState:Hide("HAT")
	owner.AnimState:Hide("HAT_HAIR")
	owner.AnimState:Show("HAIR_NOHAT")
	owner.AnimState:Show("HAIR")
	
    -- if MASKSOUND then
    -- owner.SoundEmitter:KillSound("tyrmask")
	-- end
	owner:RemoveTag("godofwar")
	if inst.fire then
	  inst.fire:Remove()
      inst.fire = nil
	end  
	owner.Transform:SetScale(1, 1, 1)	
	inst.components.fueled:StopConsuming()
end

local function fn(Sim)
    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
	MakeInventoryPhysics(inst)

    anim:SetBank("tyrmask")
    anim:SetBuild("tyrmask")
    anim:PlayAnimation("anim")
	MakeInventoryFloatable(inst, "idle_water", "anim")
	
	inst:AddComponent("equippable")
    inst.components.equippable.equipslot = EQUIPSLOTS.HEAD

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = "images/inventoryimages/tyrmask.xml"
	

	inst:AddComponent("fueled")
    inst.components.fueled.fueltype = "ROSE"
    inst.components.fueled:InitializeFuelLevel(TUNING.MASK_FUEL_TIME)
    inst.components.fueled:SetDepletedFn(setdepleted)
	inst.components.fueled.ontakefuelfn = ontakefuel 
	inst.components.fueled.accepting = true
	     
    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)		
	
	inst:DoTaskInTime(0.0001, function() 
	    test(inst)
	end )

    return inst
end
 
return Prefab( "common/inventory/tyrmask", fn or simple, assets)